<html>
<head>
<title>Ogre::WorkQueue Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1WorkQueue.html">WorkQueue</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::WorkQueue Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::WorkQueue" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>Interface to a general purpose request / response style background work queue.  
 <a href="classOgre_1_1WorkQueue.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::WorkQueue:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1WorkQueue__inherit__graph.gif" border="0" usemap="#Ogre_1_1WorkQueue_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1WorkQueue_inherit__map" id="Ogre_1_1WorkQueue_inherit__map">
<area shape="rect" id="node5" href="classOgre_1_1DefaultWorkQueueBase.html" title="Base for a general purpose request / response style background work queue." alt="" coords="5,160,203,189"/><area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="61,5,147,35"/><area shape="rect" id="node7" href="classOgre_1_1DefaultWorkQueue.html" title="Implementation of a general purpose request / response style background work queue." alt="" coords="20,237,188,267"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1WorkQueue-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue_1_1Request.html">Request</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">General purpose request structure.  <a href="classOgre_1_1WorkQueue_1_1Request.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html">RequestHandler</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Interface definition for a handler of requests.  <a href="classOgre_1_1WorkQueue_1_1RequestHandler.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1WorkQueue_1_1Response.html">Response</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">General purpose response structure.  <a href="structOgre_1_1WorkQueue_1_1Response.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html">ResponseHandler</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Interface definition for a handler of responses.  <a href="classOgre_1_1WorkQueue_1_1ResponseHandler.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef unsigned long long int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76">RequestID</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Numeric identifier for a request.  <a href="#a1908257e726af6caa80f1a6cd5682d76"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a522d959bdec37026c5ad9eb2e2b189cc">WorkQueue</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a2e7a64f2d114bf2828355e83e43f8172">~WorkQueue</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#ad6d7aeeb4b1e4e8eed931cb17d63add3">startup</a> (bool forceRestart=true)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Start up the queue with the options that have been set.  <a href="#ad6d7aeeb4b1e4e8eed931cb17d63add3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#aa0687acbbe081ba2a3ae3c3bdbfca6ff">addRequestHandler</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html">RequestHandler</a> *rh)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a request handler instance to the queue.  <a href="#aa0687acbbe081ba2a3ae3c3bdbfca6ff"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#aae885bf0b8988f2353659d896bfa6b78">removeRequestHandler</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html">RequestHandler</a> *rh)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a request handler.  <a href="#aae885bf0b8988f2353659d896bfa6b78"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#ac7a22c908d9859d29c22fc8b73a7c735">addResponseHandler</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="el" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html">ResponseHandler</a> *rh)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a response handler instance to the queue.  <a href="#ac7a22c908d9859d29c22fc8b73a7c735"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#ab8160c231f7f7706030432c3c585e589">removeResponseHandler</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="el" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html">ResponseHandler</a> *rh)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a <a class="el" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a> handler.  <a href="#ab8160c231f7f7706030432c3c585e589"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76">RequestID</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#ad3e1602a8b01d1fe068eb9705060bcfd">addRequest</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel, <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> requestType, const <a class="el" href="classOgre_1_1Any.html">Any</a> &amp;rData, <a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> retryCount=0, bool forceSynchronous=false)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a new request to the queue.  <a href="#ad3e1602a8b01d1fe068eb9705060bcfd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a5c3f58ddc03546ba2a5c510cbca0aae6">abortRequest</a> (<a class="el" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76">RequestID</a> id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Abort a previously issued request.  <a href="#a5c3f58ddc03546ba2a5c510cbca0aae6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#ac885db05201bde87b65c27e1b7cf8af4">abortRequestsByChannel</a> (<a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> channel)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Abort all previously issued requests in a given channel.  <a href="#ac885db05201bde87b65c27e1b7cf8af4"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#aae92816d648918690f76f6fe14f125c0">abortAllRequests</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Abort all previously issued requests.  <a href="#aae92816d648918690f76f6fe14f125c0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a414eb873108df39549cc79d8246994d3">setPaused</a> (bool pause)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set whether to pause further processing of any requests.  <a href="#a414eb873108df39549cc79d8246994d3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a79a71d8b70010d28043a2fef2c3e2cf8">isPaused</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether the queue is paused ie not sending more work to workers.  <a href="#a79a71d8b70010d28043a2fef2c3e2cf8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a1fd22283445612a4d0e020917f1582b9">setRequestsAccepted</a> (bool accept)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set whether to accept new requests or not.  <a href="#a1fd22283445612a4d0e020917f1582b9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#abc8685f2e0f4921468f8cf7cb5f2b2b3">getRequestsAccepted</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns whether requests are being accepted right now.  <a href="#abc8685f2e0f4921468f8cf7cb5f2b2b3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#aa4c64bf597bd87860dc297f0ac7af463">processResponses</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Process the responses in the queue.  <a href="#aa4c64bf597bd87860dc297f0ac7af463"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a9b605e17372e8a45eab9471955979d4a">getResponseProcessingTimeLimit</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the time limit imposed on the processing of responses in a single frame, in milliseconds (0 indicates no limit).  <a href="#a9b605e17372e8a45eab9471955979d4a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a9b631e09dcaafb4a341eff307f00feca">setResponseProcessingTimeLimit</a> (unsigned long ms)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the time limit imposed on the processing of responses in a single frame, in milliseconds (0 indicates no limit).  <a href="#a9b631e09dcaafb4a341eff307f00feca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a42d64d8891849878e3d1afb66fa0ce19">shutdown</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Shut down the queue.  <a href="#a42d64d8891849878e3d1afb66fa0ce19"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a9a550b2e870c3cf2fb7dc6732ceed3e5">getChannel</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;channelName)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a channel ID for a given channel name.  <a href="#a9a550b2e870c3cf2fb7dc6732ceed3e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef std::map&lt; <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a49e33316b1140dca7d9aa81e5b47d49b">ChannelMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1WorkQueue.html#a49e33316b1140dca7d9aa81e5b47d49b">ChannelMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#a4e043b97536f11e70189d8184fbaa7f8">mChannelMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1WorkQueue.html#ad2ff94d54fe961e1e59558f361093b65">mNextChannel</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Interface to a general purpose request / response style background work queue. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>A work queue is a simple structure, where requests for work are placed onto the queue, then removed by a worker for processing, then finally a response is placed on the result queue for the originator to pick up at their leisure. The typical use for this is in a threaded environment, although any kind of deferred processing could use this approach to decouple and distribute work over a period of time even if it was single threaded. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>WorkQueues also incorporate thread pools. One or more background worker threads can wait on the queue and be notified when a request is waiting to be processed. For maximal thread usage, a <a class="el" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a> instance should be shared among many sources of work, rather than many work queues being created. This way, you can share a small number of hardware threads among a large number of background tasks. This doesn't mean you have to implement all the request processing in one class, you can plug in many handlers in order to process the requests. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This is an abstract interface definition; users can subclass this and provide their own implementation if required to centralise task management in their own subsystems. We also provide a default implementation in the form of <a class="el" href="classOgre_1_1DefaultWorkQueue.html" title="Implementation of a general purpose request / response style background work queue.">DefaultWorkQueue</a>. </dd></dl>

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00069">69</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a49e33316b1140dca7d9aa81e5b47d49b"></a><!-- doxytag: member="Ogre::WorkQueue::ChannelMap" ref="a49e33316b1140dca7d9aa81e5b47d49b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;<a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>, <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&gt; <a class="el" href="classOgre_1_1WorkQueue.html#a49e33316b1140dca7d9aa81e5b47d49b">Ogre::WorkQueue::ChannelMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00072">72</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1908257e726af6caa80f1a6cd5682d76"></a><!-- doxytag: member="Ogre::WorkQueue::RequestID" ref="a1908257e726af6caa80f1a6cd5682d76" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef unsigned long long int <a class="el" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76">Ogre::WorkQueue::RequestID</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Numeric identifier for a request. </p>

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00078">78</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a522d959bdec37026c5ad9eb2e2b189cc"></a><!-- doxytag: member="Ogre::WorkQueue::WorkQueue" ref="a522d959bdec37026c5ad9eb2e2b189cc" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1WorkQueue.html#a522d959bdec37026c5ad9eb2e2b189cc">Ogre::WorkQueue::WorkQueue</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00220">220</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2e7a64f2d114bf2828355e83e43f8172"></a><!-- doxytag: member="Ogre::WorkQueue::~WorkQueue" ref="a2e7a64f2d114bf2828355e83e43f8172" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1WorkQueue.html#a2e7a64f2d114bf2828355e83e43f8172">Ogre::WorkQueue::~WorkQueue</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00221">221</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aae92816d648918690f76f6fe14f125c0"></a><!-- doxytag: member="Ogre::WorkQueue::abortAllRequests" ref="aae92816d648918690f76f6fe14f125c0" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#aae92816d648918690f76f6fe14f125c0">Ogre::WorkQueue::abortAllRequests</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Abort all previously issued requests. </p>
<p><a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> requests still waiting to be processed will be removed from the queue. <a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> requests that are being processed will still complete. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a0c50d7ab19de75a3e378ba46aa8fbf9c">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a5c3f58ddc03546ba2a5c510cbca0aae6"></a><!-- doxytag: member="Ogre::WorkQueue::abortRequest" ref="a5c3f58ddc03546ba2a5c510cbca0aae6" args="(RequestID id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#a5c3f58ddc03546ba2a5c510cbca0aae6">Ogre::WorkQueue::abortRequest</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76">RequestID</a>&#160;</td>
          <td class="paramname"><em>id</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Abort a previously issued request. </p>
<p>If the request is still waiting to be processed, it will be removed from the queue. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">id</td><td>The ID of the previously issued request. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a634fdd65c89267fc6aeca8e8f6cf5446">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="ac885db05201bde87b65c27e1b7cf8af4"></a><!-- doxytag: member="Ogre::WorkQueue::abortRequestsByChannel" ref="ac885db05201bde87b65c27e1b7cf8af4" args="(uint16 channel)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#ac885db05201bde87b65c27e1b7cf8af4">Ogre::WorkQueue::abortRequestsByChannel</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>channel</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Abort all previously issued requests in a given channel. </p>
<p><a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> requests still waiting to be processed of the given channel, will be removed from the queue. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel</td><td>The type of request to be aborted </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#ae8cf46d021a09310d1ab96aa1a2c0d08">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="ad3e1602a8b01d1fe068eb9705060bcfd"></a><!-- doxytag: member="Ogre::WorkQueue::addRequest" ref="ad3e1602a8b01d1fe068eb9705060bcfd" args="(uint16 channel, uint16 requestType, const Any &amp;rData, uint8 retryCount=0, bool forceSynchronous=false)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76">RequestID</a> <a class="el" href="classOgre_1_1WorkQueue.html#ad3e1602a8b01d1fe068eb9705060bcfd">Ogre::WorkQueue::addRequest</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>requestType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Any.html">Any</a> &amp;&#160;</td>
          <td class="paramname"><em>rData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&#160;</td>
          <td class="paramname"><em>retryCount</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>forceSynchronous</em> = <code>false</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a new request to the queue. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel</td><td>The channel this request will go into = 0; the channel is the top-level categorisation of the request </td></tr>
    <tr><td class="paramname">requestType</td><td>An identifier that's unique within this queue which identifies the type of the request (user decides the actual value) </td></tr>
    <tr><td class="paramname">rData</td><td>The data required by the request process. </td></tr>
    <tr><td class="paramname">retryCount</td><td>The number of times the request should be retried if it fails. </td></tr>
    <tr><td class="paramname">forceSynchronous</td><td>Forces the request to be processed immediately even if threading is enabled. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>The ID of the request that has been added </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#ae56e676115ca423252d775fab3344823">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="aa0687acbbe081ba2a3ae3c3bdbfca6ff"></a><!-- doxytag: member="Ogre::WorkQueue::addRequestHandler" ref="aa0687acbbe081ba2a3ae3c3bdbfca6ff" args="(uint16 channel, RequestHandler *rh)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#aa0687acbbe081ba2a3ae3c3bdbfca6ff">Ogre::WorkQueue::addRequestHandler</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html">RequestHandler</a> *&#160;</td>
          <td class="paramname"><em>rh</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a request handler instance to the queue. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Every queue must have at least one request handler instance for each channel in which requests are raised. If you add more than one handler per channel, then you must implement canHandleRequest differently in each if you wish them to respond to different requests. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel</td><td>The channel for requests you want to handle </td></tr>
    <tr><td class="paramname">rh</td><td>Your handler </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a7fc21f1afa5edb2a919f8ba2febfb1a3">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="ac7a22c908d9859d29c22fc8b73a7c735"></a><!-- doxytag: member="Ogre::WorkQueue::addResponseHandler" ref="ac7a22c908d9859d29c22fc8b73a7c735" args="(uint16 channel, ResponseHandler *rh)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#ac7a22c908d9859d29c22fc8b73a7c735">Ogre::WorkQueue::addResponseHandler</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html">ResponseHandler</a> *&#160;</td>
          <td class="paramname"><em>rh</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a response handler instance to the queue. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Every queue must have at least one response handler instance for each channel in which requests are raised. If you add more than one, then you must implement canHandleResponse differently in each if you wish them to respond to different responses. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel</td><td>The channel for responses you want to handle </td></tr>
    <tr><td class="paramname">rh</td><td>Your handler </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a9e338627cd72591048b9de5a5f4f9770">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a9a550b2e870c3cf2fb7dc6732ceed3e5"></a><!-- doxytag: member="Ogre::WorkQueue::getChannel" ref="a9a550b2e870c3cf2fb7dc6732ceed3e5" args="(const String &amp;channelName)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="el" href="classOgre_1_1WorkQueue.html#a9a550b2e870c3cf2fb7dc6732ceed3e5">Ogre::WorkQueue::getChannel</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>channelName</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a channel ID for a given channel name. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Channels are assigned on a first-come, first-served basis and are not persistent across application instances. This method allows applications to not worry about channel clashes through manually assigned channel numbers. </dd></dl>

</div>
</div>
<a class="anchor" id="abc8685f2e0f4921468f8cf7cb5f2b2b3"></a><!-- doxytag: member="Ogre::WorkQueue::getRequestsAccepted" ref="abc8685f2e0f4921468f8cf7cb5f2b2b3" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1WorkQueue.html#abc8685f2e0f4921468f8cf7cb5f2b2b3">Ogre::WorkQueue::getRequestsAccepted</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns whether requests are being accepted right now. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a64c14e98257e6bda2435912ba3f84fc7">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a9b605e17372e8a45eab9471955979d4a"></a><!-- doxytag: member="Ogre::WorkQueue::getResponseProcessingTimeLimit" ref="a9b605e17372e8a45eab9471955979d4a" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned long <a class="el" href="classOgre_1_1WorkQueue.html#a9b605e17372e8a45eab9471955979d4a">Ogre::WorkQueue::getResponseProcessingTimeLimit</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the time limit imposed on the processing of responses in a single frame, in milliseconds (0 indicates no limit). </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a415418e6732bed1a9ab760050fd37712">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a79a71d8b70010d28043a2fef2c3e2cf8"></a><!-- doxytag: member="Ogre::WorkQueue::isPaused" ref="a79a71d8b70010d28043a2fef2c3e2cf8" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1WorkQueue.html#a79a71d8b70010d28043a2fef2c3e2cf8">Ogre::WorkQueue::isPaused</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return whether the queue is paused ie not sending more work to workers. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a76a6c29ee6c7d91f4c4f0fbd5738f184">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::WorkQueue::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::WorkQueue::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::WorkQueue::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::WorkQueue::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::WorkQueue::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::WorkQueue::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::WorkQueue::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::WorkQueue::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::WorkQueue::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::WorkQueue::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa4c64bf597bd87860dc297f0ac7af463"></a><!-- doxytag: member="Ogre::WorkQueue::processResponses" ref="aa4c64bf597bd87860dc297f0ac7af463" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#aa4c64bf597bd87860dc297f0ac7af463">Ogre::WorkQueue::processResponses</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Process the responses in the queue. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method is public, and must be called from the main render thread to 'pump' responses through the system. The method will usually try to clear all responses before returning = 0; however, you can specify a time limit on the response processing to limit the impact of spikes in demand by calling setResponseProcessingTimeLimit. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a09a2d91f22689b5aad7967cfb799c63e">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="aae885bf0b8988f2353659d896bfa6b78"></a><!-- doxytag: member="Ogre::WorkQueue::removeRequestHandler" ref="aae885bf0b8988f2353659d896bfa6b78" args="(uint16 channel, RequestHandler *rh)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#aae885bf0b8988f2353659d896bfa6b78">Ogre::WorkQueue::removeRequestHandler</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1WorkQueue_1_1RequestHandler.html">RequestHandler</a> *&#160;</td>
          <td class="paramname"><em>rh</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a request handler. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a1f0847f5d8a4f9e4703a390acacfaa84">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="ab8160c231f7f7706030432c3c585e589"></a><!-- doxytag: member="Ogre::WorkQueue::removeResponseHandler" ref="ab8160c231f7f7706030432c3c585e589" args="(uint16 channel, ResponseHandler *rh)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#ab8160c231f7f7706030432c3c585e589">Ogre::WorkQueue::removeResponseHandler</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>&#160;</td>
          <td class="paramname"><em>channel</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1WorkQueue_1_1ResponseHandler.html">ResponseHandler</a> *&#160;</td>
          <td class="paramname"><em>rh</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a <a class="el" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">Response</a> handler. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#ad8b1cec781199a65accf0024acc2c18a">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a414eb873108df39549cc79d8246994d3"></a><!-- doxytag: member="Ogre::WorkQueue::setPaused" ref="a414eb873108df39549cc79d8246994d3" args="(bool pause)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#a414eb873108df39549cc79d8246994d3">Ogre::WorkQueue::setPaused</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>pause</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set whether to pause further processing of any requests. </p>
<p>If true, any further requests will simply be queued and not processed until setPaused(false) is called. <a class="el" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a> requests which are in the process of being worked on already will still continue. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a7f471c07b8f0fdd002d6c299750a1578">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a1fd22283445612a4d0e020917f1582b9"></a><!-- doxytag: member="Ogre::WorkQueue::setRequestsAccepted" ref="a1fd22283445612a4d0e020917f1582b9" args="(bool accept)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#a1fd22283445612a4d0e020917f1582b9">Ogre::WorkQueue::setRequestsAccepted</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>accept</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set whether to accept new requests or not. </p>
<p>If true, requests are added to the queue as usual. If false, requests are silently ignored until setRequestsAccepted(true) is called. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a291e7c92efb374ec208c680375edd2ce">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a9b631e09dcaafb4a341eff307f00feca"></a><!-- doxytag: member="Ogre::WorkQueue::setResponseProcessingTimeLimit" ref="a9b631e09dcaafb4a341eff307f00feca" args="(unsigned long ms)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#a9b631e09dcaafb4a341eff307f00feca">Ogre::WorkQueue::setResponseProcessingTimeLimit</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>ms</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the time limit imposed on the processing of responses in a single frame, in milliseconds (0 indicates no limit). </p>
<p>This sets the maximum time that will be spent in <a class="el" href="classOgre_1_1WorkQueue.html#aa4c64bf597bd87860dc297f0ac7af463" title="Process the responses in the queue.">processResponses()</a> in a single frame. The default is 8ms. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueueBase.html#a7b7a4119647b82187af2341d96f51e3b">Ogre::DefaultWorkQueueBase</a>.</p>

</div>
</div>
<a class="anchor" id="a42d64d8891849878e3d1afb66fa0ce19"></a><!-- doxytag: member="Ogre::WorkQueue::shutdown" ref="a42d64d8891849878e3d1afb66fa0ce19" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#a42d64d8891849878e3d1afb66fa0ce19">Ogre::WorkQueue::shutdown</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Shut down the queue. </p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueue.html#a74aec1a66a9d5a5639a62ed33747eb76">Ogre::DefaultWorkQueue</a>, and <a class="el" href="classOgre_1_1DefaultWorkQueue.html#a74aec1a66a9d5a5639a62ed33747eb76">Ogre::DefaultWorkQueue</a>.</p>

</div>
</div>
<a class="anchor" id="ad6d7aeeb4b1e4e8eed931cb17d63add3"></a><!-- doxytag: member="Ogre::WorkQueue::startup" ref="ad6d7aeeb4b1e4e8eed931cb17d63add3" args="(bool forceRestart=true)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1WorkQueue.html#ad6d7aeeb4b1e4e8eed931cb17d63add3">Ogre::WorkQueue::startup</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>forceRestart</em> = <code>true</code></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Start up the queue with the options that have been set. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">forceRestart</td><td>If the queue is already running, whether to shut it down and restart. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultWorkQueue.html#a1a0f33724027da3501c0c8b8182480cf">Ogre::DefaultWorkQueue</a>, and <a class="el" href="classOgre_1_1DefaultWorkQueue.html#a1a0f33724027da3501c0c8b8182480cf">Ogre::DefaultWorkQueue</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a4e043b97536f11e70189d8184fbaa7f8"></a><!-- doxytag: member="Ogre::WorkQueue::mChannelMap" ref="a4e043b97536f11e70189d8184fbaa7f8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1WorkQueue.html#a49e33316b1140dca7d9aa81e5b47d49b">ChannelMap</a> <a class="el" href="classOgre_1_1WorkQueue.html#a4e043b97536f11e70189d8184fbaa7f8">Ogre::WorkQueue::mChannelMap</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00073">73</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad2ff94d54fe961e1e59558f361093b65"></a><!-- doxytag: member="Ogre::WorkQueue::mNextChannel" ref="ad2ff94d54fe961e1e59558f361093b65" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="el" href="classOgre_1_1WorkQueue.html#ad2ff94d54fe961e1e59558f361093b65">Ogre::WorkQueue::mNextChannel</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreWorkQueue_8h_source.html#l00074">74</a> of file <a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreWorkQueue_8h_source.html">OgreWorkQueue.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:10
</p>
</body>
</html>
